#ifndef gl__GLObject_h
#define gl__GLObject_h

namespace gl
{
  /**
   * オープンGLリソースの基本クラス。
   */
  class GLObject
  {
    /**
     * suppress_gl_delete()はgl::Contextクラスからのみ呼び出せる。
     */
    friend class Context ;

    /**
     * コンテキストの破棄に伴い削除されるので、GLの削除関数を呼びださないようにする。
     */
    void suppress_gl_delete() { m_suppress_gl_delete = true ; }

  protected :
    GLObject() {}

  public :
    virtual ~GLObject() = 0 ;

  protected :
    bool m_suppress_gl_delete = false ;
  } ;
}


#endif
